<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/include/rdc_delete_stmt_.incl.pl1</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="pl1">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.pliRainbow_lv0_o0 { color: #add8e6; }
.pliRainbow_lv0_p0 { color: #add8e6; }
.Repeat { color: #af87d7; font-weight: bold; }
.LineNr { color: #585858; }
.Conditional { color: #af87d7; font-weight: bold; }
.Macro { color: #00afaf; }
.Number { color: #ff5faf; }
.Boolean { color: #d7af00; font-weight: bold; }
.Operator { color: #5fafd7; }
.Keyword { color: #00afaf; }
.Comment { color: #808080; }
.Normal { color: #d0d0d0; background-color: #000000; padding-bottom: 1px; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span><span class="Comment">/* START OF:        rdc_delete_stmt_.incl.pl1                 *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L4" class="LineNr"> 4 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L5" class="LineNr"> 5 </span>          <span class="Comment">/* N^H__^Ha_^Hm_^He:  rdc_delete_stmt_.incl.pl1                                                     */</span>
<span id="L6" class="LineNr"> 6 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L7" class="LineNr"> 7 </span>          <span class="Comment">/*      This include segment is used by compilers generated by the reduction_compiler.    */</span>
<span id="L8" class="LineNr"> 8 </span>          <span class="Comment">/* It includes a procedure which deletes all of the tokens associated with the current    */</span>
<span id="L9" class="LineNr"> 9 </span>          <span class="Comment">/* statement (i.e., the statement which contains the token identified by Pthis_token).    */</span>
<span id="L10" class="LineNr">10 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L11" class="LineNr">11 </span>          <span class="Comment">/* S^H__^Ht_^Ha_^Ht_^Hu_^Hs                                                                                   */</span>
<span id="L12" class="LineNr">12 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L13" class="LineNr">13 </span>          <span class="Comment">/* 0) created by:  G. C. Dixon  in  February, 1975.                                       */</span>
<span id="L14" class="LineNr">14 </span>          <span class="Comment">/*                                                                                        */</span>
<span id="L15" class="LineNr">15 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  * */</span>
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>
<span id="L18" class="LineNr">18 </span><span class="Normal">DELETE_STMT</span><span class="Operator">:</span> <span class="Keyword">procedure</span><span class="Normal">;</span>
<span id="L19" class="LineNr">19 </span>
<span id="L20" class="LineNr">20 </span>     <span class="Keyword">dcl</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Plast</span><span class="pliRainbow_lv0_o0">,</span> <span class="Normal">Pnext</span><span class="pliRainbow_lv0_p0">)</span>                 <span class="Macro">ptr</span><span class="Normal">,</span>                <span class="Comment">/* ptr to (first, last) token to be deleted.      */</span>
<span id="L21" class="LineNr">21 </span>          <span class="Normal">Ssearching</span>                    <span class="Macro">bit</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">1</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">aligned</span><span class="Normal">;</span>     <span class="Comment">/* on if scan for first/last token continuing.    */</span>
<span id="L22" class="LineNr">22 </span>
<span id="L23" class="LineNr">23 </span>          <span class="Conditional">if</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span> <span class="Keyword">return</span><span class="Normal">;</span>                <span class="Comment">/* if input list exhausted, we can't do anything. */</span>
<span id="L24" class="LineNr">24 </span>          <span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Normal">Pthis_token</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span><span class="Normal">;</span>               <span class="Comment">/* address the statement descriptor of &quot;current&quot;  */</span>
<span id="L25" class="LineNr">25 </span>          <span class="Conditional">if</span> <span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span> <span class="Keyword">return</span><span class="Normal">;</span>                      <span class="Comment">/*   token, if it exists.                         */</span>
<span id="L26" class="LineNr">26 </span>          <span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Normal">Pthis_token</span><span class="Normal">;</span>                              <span class="Comment">/* start scanning with &quot;current&quot; token.           */</span>
<span id="L27" class="LineNr">27 </span>          <span class="Normal">Ssearching</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">1</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>                                <span class="Comment">/* set switch indicating search still continuing. */</span>
<span id="L28" class="LineNr">28 </span>          <span class="Keyword">do</span> <span class="Repeat">while</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Ssearching</span> <span class="Operator">&amp;</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">^=</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L29" class="LineNr">29 </span>               <span class="Conditional">if</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Normal">Pstmt</span> <span class="Keyword">then</span>
<span id="L30" class="LineNr">30 </span>                    <span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span><span class="Normal">;</span>           <span class="Comment">/* scan backward for 1st _^Hn_^Ho_^Hn-^H__^Hd_^He_^Hl_^He_^Ht_^He_^Hd token of stmt*/</span>
<span id="L31" class="LineNr">31 </span>               <span class="Conditional">else</span> <span class="Normal">Ssearching</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">0</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>                      <span class="Comment">/* when found, stop searching.                    */</span>
<span id="L32" class="LineNr">32 </span>               <span class="Keyword">end</span><span class="Normal">;</span>                                         <span class="Comment">/* Recall that 1st token of stmt (ie, token       */</span>
<span id="L33" class="LineNr">33 </span>                                                            <span class="Comment">/*   pointed to by stmt.Pfirst_token) may have    */</span>
<span id="L34" class="LineNr">34 </span>                                                            <span class="Comment">/*   been deleted.                                */</span>
<span id="L35" class="LineNr">35 </span>          <span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Normal">Pthis_token</span><span class="Normal">;</span>                              <span class="Comment">/* start scanning forward with &quot;current&quot; token.   */</span>
<span id="L36" class="LineNr">36 </span>          <span class="Normal">Ssearching</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">1</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>
<span id="L37" class="LineNr">37 </span>          <span class="Keyword">do</span> <span class="Repeat">while</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">Ssearching</span> <span class="Operator">&amp;</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">^=</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L38" class="LineNr">38 </span>               <span class="Conditional">if</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span> <span class="Operator">=</span> <span class="Normal">Pstmt</span> <span class="Keyword">then</span>
<span id="L39" class="LineNr">39 </span>                    <span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span><span class="Normal">;</span>           <span class="Comment">/* scan forward for last _^Hn_^Ho_^Hn-^H__^Hd_^He_^Hl_^He_^Ht_^He_^Hd token of stmt*/</span>
<span id="L40" class="LineNr">40 </span>               <span class="Conditional">else</span> <span class="Normal">Ssearching</span> <span class="Operator">=</span> <span class="Operator">&quot;</span><span class="Number">0</span><span class="Operator">&quot;</span><span class="Keyword">b</span><span class="Normal">;</span>                      <span class="Comment">/* when found, stop searching.                    */</span>
<span id="L41" class="LineNr">41 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L42" class="LineNr">42 </span>          <span class="Conditional">if</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>               <span class="Comment">/* if there is no next statement, and             */</span>
<span id="L43" class="LineNr">43 </span>               <span class="Conditional">if</span> <span class="Normal">SPDL</span> <span class="Keyword">then</span>                                 <span class="Comment">/*   if in PUSH DOWN LANGUAGE mode, and           */</span>
<span id="L44" class="LineNr">44 </span>                    <span class="Conditional">if</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>     <span class="Comment">/*   if there are no more tokens before the       */</span>
<span id="L45" class="LineNr">45 </span>                         <span class="Normal">Ptoken</span><span class="Normal">,</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>        <span class="Comment">/*   &quot;current&quot; statement, then input exhausted.   */</span>
<span id="L46" class="LineNr">46 </span>                    <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L47" class="LineNr">47 </span>                         <span class="Normal">Ptoken</span><span class="Normal">,</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span><span class="Normal">;</span>
<span id="L48" class="LineNr">48 </span>                                                            <span class="Comment">/*   otherwise, make token preceding the &quot;current&quot;*/</span>
<span id="L49" class="LineNr">49 </span>                                                            <span class="Comment">/*   statement the &quot;current&quot; token.               */</span>
<span id="L50" class="LineNr">50 </span>                         <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>                <span class="Comment">/*   indicate that input list exhausted.  Only the*/</span>
<span id="L51" class="LineNr">51 </span>                                                            <span class="Comment">/*   tokens before the new &quot;current&quot; token exist. */</span>
<span id="L52" class="LineNr">52 </span>                         <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L53" class="LineNr">53 </span>               <span class="Conditional">else</span> <span class="Normal">Ptoken</span><span class="Normal">,</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>             <span class="Comment">/* not in PUSH DOWN LANGUAGE - input exhausted.   */</span>
<span id="L54" class="LineNr">54 </span>          <span class="Conditional">else</span> <span class="Keyword">do</span><span class="Normal">;</span>
<span id="L55" class="LineNr">55 </span>               <span class="Normal">Ptoken</span><span class="Normal">,</span> <span class="Normal">Pthis_token</span> <span class="Operator">=</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span><span class="Normal">;</span>  <span class="Comment">/* normally, token following &quot;current&quot; statement  */</span>
<span id="L56" class="LineNr">56 </span>                                                            <span class="Comment">/*   becomes the &quot;current&quot; token.                 */</span>
<span id="L57" class="LineNr">57 </span>               <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span><span class="Normal">;</span>          <span class="Comment">/* unthread the deleted tokens.                   */</span>
<span id="L58" class="LineNr">58 </span>               <span class="Conditional">if</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">^=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>
<span id="L59" class="LineNr">59 </span>                    <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Normal">Ptoken</span><span class="Normal">;</span>
<span id="L60" class="LineNr">60 </span>               <span class="Keyword">end</span><span class="Normal">;</span>
<span id="L61" class="LineNr">61 </span>
<span id="L62" class="LineNr">62 </span>          <span class="Conditional">if</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>               <span class="Comment">/* unthread statement descriptor from list.       */</span>
<span id="L63" class="LineNr">63 </span>               <span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>
<span id="L64" class="LineNr">64 </span>          <span class="Conditional">else</span> <span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span><span class="Normal">;</span>
<span id="L65" class="LineNr">65 </span>          <span class="Conditional">if</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>
<span id="L66" class="LineNr">66 </span>               <span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Boolean">null</span><span class="Normal">;</span>
<span id="L67" class="LineNr">67 </span>          <span class="Conditional">else</span> <span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">token</span><span class="Normal">.</span><span class="Normal">Pstmt</span><span class="Normal">;</span>
<span id="L68" class="LineNr">68 </span>          <span class="Conditional">if</span> <span class="Normal">Pnext</span> <span class="Operator">^=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>
<span id="L69" class="LineNr">69 </span>               <span class="Normal">Pnext</span> <span class="Operator">-&gt;</span> <span class="Normal">stmt</span><span class="Normal">.</span><span class="Normal">Plast</span> <span class="Operator">=</span> <span class="Normal">Plast</span><span class="Normal">;</span>
<span id="L70" class="LineNr">70 </span>          <span class="Conditional">if</span> <span class="Normal">Plast</span> <span class="Operator">^=</span> <span class="Boolean">null</span> <span class="Keyword">then</span>
<span id="L71" class="LineNr">71 </span>               <span class="Normal">Plast</span> <span class="Operator">-&gt;</span> <span class="Normal">stmt</span><span class="Normal">.</span><span class="Normal">Pnext</span> <span class="Operator">=</span> <span class="Normal">Pnext</span><span class="Normal">;</span>
<span id="L72" class="LineNr">72 </span>
<span id="L73" class="LineNr">73 </span>          <span class="Keyword">end</span> <span class="Normal">DELETE_STMT</span><span class="Normal">;</span>
<span id="L74" class="LineNr">74 </span>
<span id="L75" class="LineNr">75 </span><span class="Comment">/* END OF:          rdc_delete_stmt_.incl.pl1                 *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
